/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Benjamin Grauer
   co-programmer: ...

   this file extends the framework file, so it renders what i want.
*/

#include "framework.h"

#include "fields.h"
#include "stdlibincl.h"
#include "light.h"

#include "cd_engine.h"

#include "md2Model.h"

MD2Model* model;

void Framework::moduleInit(int argc, char** argv)
{
  CDEngine::getInstance();
  //CDEngine::getInstance()->debug();

  model = new MD2Model("models/tris.md2", "models/tris.pcx");
  model->tick(0.1f);

//   int const length = 6;
//   sVec3D* vertList = new sVec3D[length];
//   sVec3D data[length]  = {{5.0, 0.0, 0.0},{2.0, 0.0, 5.0},{14.0, 0.0, 0.0}, {5.0, 0.0, 1.0}, {12.0, 0.0, 8.0}, {3.0, 5.0, 4.9}};
//
//   for(int i = 0; i < length; ++i)
//   {
//     vertList[i][0] = data[i][0];
//     vertList[i][1] = data[i][1];
//     vertList[i][2] = data[i][2];
//   }

  CDEngine::getInstance()->debugSpawnTree(4, model->data->pVertices, model->data->numVertices);


  LightManager* lightMan = LightManager::getInstance();
  lightMan->setAmbientColor(.1,.1,.1);
  lightMan->addLight();
  lightMan->addLight();
  lightMan->setPosition(10, 20, 100);
}


void Framework::moduleEventHandler(SDL_Event* event)
{
  switch (event->type)
  {
    case SDL_KEYDOWN:
      switch (event->key.keysym.sym)
      {
        case SDLK_i:
          break;
        case SDLK_1:
          printf("alsjdf;lajsfd;lajsdf\n");
          break;
      }
  }
}


void Framework::moduleTick(float dt)
{
}


void Framework::moduleDraw() const
{
  CDEngine::getInstance()->drawBV(3);

  LightManager::getInstance()->draw();

  //model->draw();
}


void Framework::moduleHelp(void) const
{
  PRINT(0)("\n");
  PRINT(0)("i - print debug information of Collision-detection\n");
  PRINT(0)("\n");
}


void Framework::moduleInitGui(int argc, char** argv)
{
  Window* guiMainWindow = NULL;

  initGUI(0, NULL);

  guiMainWindow = new Window("Collision_detection");
  {
    //all the Widgets you need
  }
  Window::mainWindow->showall();
  Window::mainWindow->setSize(300, 500);
}
